package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.sun.star.uno.XComponentContext;

import pro.litvinovg.xml.Debug;

public class ConfigurationReader {
	
	HashMap<String,String> options = new HashMap<String,String>();
	private XComponentContext context;

	public ConfigurationReader(HashMap<String, Component> configuration, XComponentContext context) {
		this.context = context;
		readOptions(configuration);
	}

	private void readOptions(HashMap<String, Component> configuration) {
		Set<String> keys = configuration.keySet();
		for (String optionName : keys) {
			String optionValue = null;
			Component component = configuration.get(optionName);
			if (component.getClass().equals(JTextField.class)) {
				optionValue = ((JTextField) component).getText();
			} else if (component.getClass().equals(JCheckBox.class)) {
				optionValue = Boolean.toString(((JCheckBox) component).isSelected());
			} else if (component.getClass().equals(JLabel.class)) {
				optionValue = ((JLabel) component).getText();
			}
			options.put(optionName, optionValue);
			//Debug.printLog(optionName + " : " + optionValue, context);

		}
		
		
	}

	public String[] getCommandLine() {
		List<String> args = new ArrayList<String>();
		String format = options.get("targetFormat");
		if (format == null) {
			Debug.printLog("target format is not set", context);
			return null;
		} else {
			options.remove("targetFormat");
		}
		String inputFile = options.get("inputFile");
		if (inputFile == null) {
			Debug.printLog("no input file", context);
			return null;
		} else {
			options.remove("inputFile");
		}
		String outputFile = options.get("outputFile");
		if (outputFile == null) {
			//Debug.printLog("no output file set", context);
		} else {
			options.remove("outputFile");
		}
		args.add("-"+format);
		for (String key: options.keySet()) {
			String value = options.get(key);
			if( value != null && !value.isEmpty()) {
				args.add("-"+key);
				args.add(value);
			}
		}
		args.add(inputFile);
		if (outputFile != null) {
			args.add(outputFile);
		}
		String sout = "";
		for (String val: args) {
			sout += val+" ";;
		}
		Debug.printLog(sout, context);
		String[] array = args.toArray(new String[0]);
		return array; 
	}

}
